; THE CAVE ---- (c)2013 BY PSY
; http://PSY-LABS.COM

; Made for Blitzforum Minimalist Competition #1
; http://www.blitzforum.de/forum/viewtopic.php?t=39245&postdays=0&postorder=Asc&start=0
; THE CAVE is available @ http://pheryllt.de/_misc/blitzforum/TheCave-PSY-MinimalistCompo2013.rar


; ******************
; ***  GRAPHICS  ***
; ******************

; CAVE.BMP			90 * 81 * 1Bit( 2 colours) / 8 = 911.25
; ITEM1.PNG			24 * 24 * 1Bit( 2 colours) / 8 = 072.00
; ITEM1.PNG			24 * 24 * 1Bit( 2 colours) / 8 = 072.00
; ITEM1.PNG			24 * 24 * 1Bit( 2 colours) / 8 = 072.00
; ITEM1.PNG			24 * 24 * 1Bit( 2 colours) / 8 = 072.00
; ITEM1.PNG			24 * 24 * 1Bit( 2 colours) / 8 = 072.00
; OBSTACLE1.PNG		64 * 48 * 1Bit( 2 colours) / 8 = 384.00
; OBSTACLE1.PNG		64 * 48 * 1Bit( 2 colours) / 8 = 384.00
; OBSTACLE1.PNG		64 * 48 * 1Bit( 2 colours) / 8 = 384.00
; OBSTACLE1.PNG		64 * 48 * 1Bit( 2 colours) / 8 = 384.00
; OBSTACLE1.PNG		64 * 48 * 1Bit( 2 colours) / 8 = 384.00
; PLAYER.PNG		32 * 32 * 4Bit(16 colours) / 8 = 512.00
;==========================================================
; TOTAL BYTE USAGE : 								3703.25

Graphics 640,480,16,1		
SetBuffer BackBuffer()


Type TObstacle				
	Field x%, y%			
	Field beatenBy%			
	Field SX%, SY%
	Field destroyed%
	Field image%
End Type

Global obstacle.TObstacle

Type TItem
	Field x%, y%
	Field SX%, SY%
	Field owned%
	Field ID%
	Field image%
End Type

Global item.TItem



Local i%

Global Xscroll%	= 3													; 2
Global Yscroll% = 4													; 2
Global playerX% = 350												; 2
Global playerY% = 250												; 2
Global cave% 	= LoadImage ("gfx/cave.bmp")						; 3
Global player	= LoadImage ("gfx/player.png")						; 3			TOTAL 14





For i=1 To 5														; 4
	item.TItem			= New TItem									; 3
	item\ID 			= i											; 2
	item\x 				= 260										; 2
	item\y 				= 160										; 2
	item\SX 			= i * 1.5									; 3
	item\SY 			= i + 3										; 3
	item\image			= LoadImage("gfx/item" + i + ".png")		; 4
	
	obstacle.TObstacle	= New TObstacle								; 3
	obstacle\beatenBy	= i											; 2
	obstacle\x 			= 320										; 2
	obstacle\y 			= 96										; 2
	obstacle\SX 		= i + 3										; 3
	obstacle\SY 		= i											; 2
	obstacle\image		= LoadImage("gfx/obstacle" + i + ".png")	; 4			TOTAL 55			
Next




Repeat
	Cls
	
	
	Render()																								; 1
	
	
	If playerX>616 Then playerX = 8   : Xscroll = (Xscroll + 1) Mod 9  										; 10
	If playerX<8   Then playerX = 616 : Xscroll = (Xscroll - 1) Mod 9 : If Xscroll = -1 Then Xscroll = 8	; 15
	If playerY>408 Then playerY = 8   : Yscroll = (Yscroll + 1) Mod 9										; 10
	If playerY<8   Then playerY = 408 : Yscroll = (Yscroll - 1) Mod 9 : If Yscroll = -1 Then Yscroll = 8	; 15
	
	If KeyDown(205) And NoWall(20,0)  Then playerX = playerX + 4  											; 9
	If KeyDown(203) And NoWall(-20,0) Then playerX = playerX - 4											; 9
	If KeyDown(208) And NoWall(0,20)  Then playerY = playerY + 4											; 9
	If KeyDown(200) And NoWall(0,-20) Then playerY = playerY - 4											; 9			TOTAL 142
	
	
	Flip 1
Until KeyHit(1)
End








Function NoWall(x%,y%)
	Local rgb%
	
	rgb = ReadPixel(playerX + x, playerY + y, BackBuffer()) 					; 7
	If rgb = -16777216 Then Return 1 											; 5			TOTAL 154
	
End Function




Function Render()
	Local x%, y%, rgb%
	
	
	Color 0,0,$00CC44															; 4
	For x=0 To 9																; 4
		For y=0 To 8															; 4
			rgb = ReadPixel(Xscroll*10 + x, Yscroll*9 + y, ImageBuffer(cave))	; 10
			If rgb <> -16777216 Then Rect x*64, y*48, 64, 48 					; 10			TOTAL 186
		Next
	Next
	
	
	For item.TItem = Each TItem																													; 4
		If item\SX = Xscroll And item\SY = Yscroll And item\owned = False																		; 7
			DrawImage item\image, item\x, item\y																								; 4
			item\owned = (Abs(playerX - item\x) + Abs(playerY - item\y)) < 50																	; 8
		EndIf
		If item\owned Then DrawImage item\image, 40*item\ID, 450																				; 7
		
		For obstacle.TObstacle = Each TObstacle 																								; 4
			If obstacle\SX = Xscroll And obstacle\SY = Yscroll And obstacle\destroyed = False													; 7
				DrawImage obstacle\image, obstacle\x, obstacle\y 																				; 4
				obstacle\destroyed = (obstacle\beatenBy = item\ID And item\owned And Abs(playerX - obstacle\x) + Abs(playerY - obstacle\y)<95)	; 11
			EndIf
		Next
	Next
	
	DrawImage player, playerX-16, playerY-16																									; 6
	
	If Xscroll = 8 And Yscroll = 0 Then RuntimeError "YO"																						; 8 		TOTAL 256
	
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D