'total: 184 byte

Graphics 640, 640

																											'+++ 10 byte

Type TCoin
	
	Field X																									'1 byte
	Field Y																									'1 byte
	Field Obstacle																							'1 byte
	
End Type



SetClsColor 255, 255, 255																					'4 byte


Global Level
Global CoinList:TList
Global CoinCount
Global PlayerAngle:Float
Global PlayerSpeed:Float
Global PlayerDistance

PlayerDistance = 15																							'2 byte


NextLevel()																									'1 byte

'Main loop																									'+++ 117 byte
Repeat
	
	SetColor 0,0,0																							'4 byte
	DrawOval 10,10,620,620																					'5 byte
	SetColor 255, 255, 255																					'4 byte
																											'***13 byte
	PlayerDistanceChange = KeyDown( KEY_A ) - KeyDown( KEY_S )												'5 byte
	PlayerDistance = PlayerDistance + PlayerDistanceChange													'3 byte
	PlayerAngle = PlayerAngle + PlayerSpeed																	'3 byte
	PlayerSpeed = PlayerSpeed - .001																		'3 byte
	If PlayerSpeed <= 0 Then End																			'4 byte
	If Abs( PlayerDistance ) > 294 Then PlayerDistance = PlayerDistance - PlayerDistanceChange				'7 byte
																											'***25 byte
	PlayerX = 320 + Cos( PlayerAngle ) * PlayerDistance														'5 byte
	PlayerY = 320 + Sin( PlayerAngle ) * PlayerDistance														'5 byte
	DrawOval PlayerX-16, PlayerY-16, 32, 32																	'7 byte
																											'***17 byte
	For Coin:TCoin = EachIn CoinList																		'3 byte
		If Coin.Obstacle = True Then																		'3 byte
			SetColor 255, 0, 0																				'4 byte
			DrawRect Coin.X-10, Coin.Y-10, 20, 20															'7 byte
			Distance = Sqr( (PlayerX-Coin.X)^2 + (PlayerY-Coin.Y)^2 )										'8 byte
			If Distance < 26 Then																			'3 byte
				End																							'1 byte
			End If																							'***29 byte
		Else																								'1 byte
			SetColor 255, 255, 0																			'4 byte
			DrawOval Coin.X-10, Coin.Y-10, 20, 20															'7 byte
			Distance = Sqr( (PlayerX-Coin.X)^2 + (PlayerY-Coin.Y)^2 )										'8 byte
			If Distance < 26 Then																			'3 byte
				ListRemove( CoinList, Coin )																'3 byte
				CoinCount = CoinCount - 1																	'3 byte
			End If																							'***29 byte
		End If
	Next
	
	If CoinCount = 0 Then NextLevel()																		'***4 byte
	
	
    Flip
	Cls
	
Until KeyHit( KEY_ESCAPE )


Function NextLevel()																						'+++ 57 byte
	If Level = 2 Then End																					'4 byte
	
	Level = Level + 1																						'3 byte
	CoinList = CreateList()																					'2 byte
	
	Filestream = ReadFile( String( Level ) )																'4 byte
	CoinCount = ReadByte( Filestream )																		'3 byte
	ObstacleCount = ReadByte( Filestream )																	'3 Byte
	
	For I = 1 To CoinCount																					'4 byte
		Coin:TCoin = New TCoin																				'3 byte
		Coin.X = ReadShort( Filestream )																	'3 byte
		Coin.Y = ReadShort( Filestream )																	'3 byte
		CoinList.AddLast( Coin )																			'3 byte
	Next
	
	For I = 1 To ObstacleCount																				'4 byte
		Coin:TCoin = New TCoin																				'3 byte
		Coin.X = ReadShort( Filestream )																	'3 byte
		Coin.Y = ReadShort( Filestream )																	'3 byte
		Coin.Obstacle = 1																					'2 byte
		CoinList.AddLast( Coin )																			'3 byte
	Next
	
	CloseFile( Filestream )																					'2 byte
	
	PlayerSpeed = 2																							'2 byte
End Function